#include <iostream>       // std::cout
#include <atomic>         // std::atomic
#include <thread>         // std::thread
#include <vector>         // std::vector
using namespace std;

atomic<int> global_counter( 0 );

void increase_global( int n ) { 
   for( int i = 0; i < n; ++i ) ++global_counter;
}

void increase_reference( atomic<int>& variable, int n ) {
   for( int i = 0; i < n; ++i ) ++variable;
}

int main() {
   vector<thread> threads;

   cout << "increase global counter with 10 threads..." << endl;
   for( int i = 1; i <= 10; ++i )
      threads.push_back( thread( increase_global, 1000 ) );

   cout << "increase counter (foo) with 10 threads using reference..." << endl;
   atomic<int> foo ( 0 );
   for( int i = 1; i <= 10; ++i )
      threads.push_back( thread( increase_reference, ref( foo ), 1000 ) ); 

   cout << "synchronizing all threads..." << endl;
   for( auto& th : threads ) th.join(); 

   cout << "global_counter: " << global_counter << endl;
   cout << "foo: " << foo << endl;

   return 0;
}
