#include <iostream>       // std::cout
#include <string>         // std::string
#include <sstream>        // std::ostringstream
#include <thread>         // std::thread

using namespace std;
 
void fun1() {
   string msg = string( __FUNCTION__ ) + string( " -> start\n" );
   cout << msg; // << std::endl;
}

void fun2( int x ) {
   ostringstream msg; 
   msg << __FUNCTION__ << " : " << x << " -> start" << endl;
   cout << msg.str(); 
}

struct block { double f; string s; };

void fun3( int x, float y, string z, block w ) {
   ostringstream msg; 
   msg << __FUNCTION__ << " : " << x << ", " << y << ", "
       << z << ", " << w.f << ", " << w.s << " -> start" << endl;
   cout << msg.str(); 
}

int main() {
  thread thr1( fun1 ); 
  thread thr2( fun2, 123 ); 
  block blk = { 0.123, string( "блочный параметр" ) }; 
  thread thr3( fun3, 123, 0.123e2, string( "параметр" ), blk ); 
  cout << "all threads now execute concurrently..." << endl;
  // synchronize threads - pauses until finishes:
  thr1.join(); 
  thr2.join();
  thr3.join();
  cout << "all threads completed." << endl;
  return 0;
}
