#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/wait.h>

int signum = SIGSEGV;

static char* id( void ) {
   static char msg[ 15 ];
   static struct timeval tv;
   gettimeofday( &tv, NULL );
   sprintf( msg, "[PID=%d %02lu:%06lu]:",
            getpid(), ( tv.tv_sec % 60 ), tv.tv_usec );
   return msg;
}

static void handler( int signo ) {
   printf( "%s получен сигнал %d\n", id(), signo );
   signal( signum, handler );
};

int main( int argc, char *argv[] ) { // группоавя рассылка сигнала
   int procnum = 3, i; // , sid;
   if( argc > 1 && atoi( argv[ 1 ] ) > 0 )   // число процессов
      procnum = atoi( argv[ 1 ] );
   if( argc > 2 && atoi( argv[ 2 ] ) > 0 ) { // номер сигнала
      if( 0 == sigaction( atoi( argv[ 2 ] ), NULL, NULL ) )
         signum = atoi( argv[ 2 ] );
   }
   signal( signum, handler );
   printf( "%s обрабатывается сигнал %d\n", id(), signum );
   for( i = 0; i < procnum; i++ ) {
      pid_t pid = fork();;
      if( pid > 0 ) {   // новый процесс создаёт только потомок
         waitpid( pid, NULL, 0 );
         exit( EXIT_SUCCESS );
      };
   }
   while( 1 ) pause(); // в последнем дочернем процессе
   return EXIT_SUCCESS;
};
