#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include "libdiag.h"

int main( int argc, char *argv[] ) {
   long cali = calibr( 1000 );
   unsigned long long t = rdtsc();
   pid_t pid = fork();       // процесс разветвился
   t = rdtsc() - t;
   t -= cali;
   if( pid == -1 ) perror( "fork" ), exit( EXIT_FAILURE );
   if( pid == 0 ) 
      printf( "child with PID=%d finished, start delayed %llu cycles\n", getpid(), t );
   if( pid > 0 ) {
      int status;
      wait( &status );
      printf( "parent with PID=%d finished, start delayed %llu cycles\n", getpid(), t );
   };
   return EXIT_SUCCESS;
};
