#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>
#include <spawn.h>

int main( int argc, char *const argv[], char *const env[] ) {
   if( argc != 2 || atoi( argv[ 1 ] ) <= 0 ) {
      printf( "usage: %s <number>\n", argv[ 0 ] );
      exit( EXIT_FAILURE );
   }
   printf( "PID=%d: %s %s\n", getpid(), argv[ 0 ], argv[ 1 ]  );
   if( 1 == atoi( argv[ 1 ] ) ) 
      sleep( 3 );
   else {
      sprintf( argv[ 1 ], "%d", atoi( argv[ 1 ] ) - 1 );
      pid_t pid;
      if( posix_spawn( &pid, argv[ 0 ], NULL, NULL, argv, env ) != 0 ) 
        perror( "spawn" ), exit( EXIT_FAILURE );        
      wait( NULL );
   }
   printf( "PID=%d: finished\n", getpid() );
   return EXIT_SUCCESS;
};
