#include "common.h"

void mark_point( const char* msg ) {
   struct timeval tv;
   gettimeofday( &tv, NULL );
   printf( "[%lu]: %02lu:%06lu - %s\n", 
           (long)getpid(), ( tv.tv_sec % 60 ), tv.tv_usec, msg );
}

void prepare( void ){ mark_point( __FUNCTION__ ); } 

void parent( void ) { mark_point( __FUNCTION__ ); } 

void child( void ) { mark_point( __FUNCTION__ ); } 

int main( int argc, char *argv[] ) {
   pthread_atfork( prepare, parent, child );
   mark_point( "before fork" ); 
   fork();
   mark_point( "after fork" ); 
   sleep( 1 );
   exit( EXIT_SUCCESS );
};
