#include "common.h"

char sout[ 1000 ], *pout = &sout[ 0 ];
pthread_mutex_t lock = PTHREAD_MUTEX_INITIALIZER;
pthread_barrier_t bstart;            // барьер для синхронизации начала работы

#define NREP 10
void* threadfunc ( void* data ) {
   int id = (long)data, i;
   pthread_barrier_wait( &bstart );  // синхронизация старта
   for( i = 0; i < NREP; i++ ) {
      delay( 1 );
      pthread_mutex_lock( &lock );
      *pout++ = '0' + id;
      pthread_mutex_unlock( &lock );
   }
   pthread_exit( NULL );
   return NULL;
};

int main( int argc, char *argv[] ) {
   int npth = ( argc > 1 && atoi( argv[ 1 ] ) > 0 ) ?
              atoi( argv[ 1 ] ) : 3,
       i;
   pthread_t* tid = (pthread_t*)calloc( npth, sizeof( pthread_t ) );
   pthread_barrier_init( &bstart, NULL, npth + 1 ); // спусковой механизм
   for( i = 0; i < npth; i++ )
      pthread_create( tid + i, NULL, threadfunc, (void*)(long)i );
   pthread_barrier_wait( &bstart );                 // одновременный старт потоков
   for( i = 0; i < npth; i++ )                      // ожидание завершения всех
      pthread_join( tid[ i ], NULL );
   *pout = '\0';
   printf( "%s\n", sout );
   exit( EXIT_SUCCESS );
};
