#include "common.c"
#include <sys/wait.h>
#include <sys/resource.h>

uint getkey( int argc, char **argv ) {
   char sopt[] = "t:v";
   int c;
   while( -1 != ( c = getopt( argc, argv, sopt ) ) )
      switch( c ) {
         case 't':
            if( atoi( optarg ) != 0 ) PAUSE = atoi( optarg );
            break;
         case 'v':
            debug++;
            break;
         default : exit( EXIT_FAILURE );
      }
   if( debug ) {
      printf( "parameters was:" );
      for( c = optind; c < argc; c++ ) printf( "\t<%s>", argv[ c ] );
      printf( "\n" );
   }
   return optind;
}

int main( int argc, char **argv, char **envp ) {
   printf( "число процессоров в SMP = %d\n", ncpu() );
   uint ind = getkey( argc, argv );
   if( argc == ind ) printf( "обижаешь, начальник!\n"), exit( EXIT_FAILURE ); 
   int i, n = 0;
   pid_t* pids = calloc( argc - ind, sizeof( pid_t ) );
   long* ret = calloc( argc - ind, sizeof( long ) );
   for( i = ind; i < argc; i++ ) {
      char *endptr;
      ret[ i - ind ] = strtol( argv[ i ], &endptr, 10 );
      if( *endptr != '\0' ) continue;
      n++;
   }
   if( debug ) printf( "планируется %d вычисляющих процессов, main: [%u]\n",
                       n, getpid() );
   pid_t pid;
   for( i = 0; i < n; i++ ) {
      pid = fork();
      if( pid < 0 ) {
         perror( "fork error" );
         exit( EXIT_FAILURE );
      }
      if( pid > 0 ) pids[ i ] = pid;  // родительский процесс
      if( 0 == pid ) break;           // дочерний процесс
   };
   if( pid > 0 ) {                    // в родителе только ожидаем завершений
      for( i = 0; i < n; i++ ) 
         waitpid( pids[ i ], NULL, 0 );
      exit( EXIT_SUCCESS );
   }
   else {                             // в потомках выполняем вычисления
      nice( ret[ i ] );  
      if( debug ) printf( "[%u]: nice устанавливается в %ld - %m\n", getpid(), ret[ i ] );
      signal( SIGALRM, handler );
      alarm( PAUSE );
      ret[ i ] = 0;
      while( 0 == final ) {
         one_cycle();
         ret[ i ]++;
      }
      printf( "[%u]: nice=%d - выполнено %ld циклов\n",
              getpid(), getpriority( PRIO_PROCESS, 0 ), ret[ i ] );
      exit( EXIT_SUCCESS );
   };
}

