#include "common.c"
#include <pthread.h>

pthread_barrier_t bstart;             // барьер для синхронизации начала работы

void *test( void *in ) {
   long *n = (long*)in;
   *n = 0;
   pthread_barrier_wait( &bstart );  // синхронизация старта
   while( 0 == final ) {
      one_cycle();
      (*n)++;
   }
   int policy;
   struct sched_param param;
   pthread_getschedparam( pthread_self(), &policy, &param );
   printf( "[%s]\tprio=%d - выполнено %ld циклов\n",
           SCHED_OTHER == policy ? "SCHED_OTHER" :
           SCHED_FIFO  == policy ? "SCHED_FIFO" :
           SCHED_RR    == policy ? "SCHED_RR" :
           "???",
           param.sched_priority, *n );
   return NULL;
}

int tpolicy = SCHED_OTHER;

uint getkey( int argc, char **argv ) {
   char sopt[] = "t:s:v";
   int c;
   while( -1 != ( c = getopt( argc, argv, sopt ) ) )
      switch( c ) {
         case 't':
            if( atoi( optarg ) != 0 ) PAUSE = atoi( optarg );
            break;
         case 's':
            tpolicy = ( 'o' == optarg[ 0 ] ) ? SCHED_OTHER :
                      ( 'f' == optarg[ 0 ] ) ? SCHED_FIFO :
                      ( 'r' == optarg[ 0 ] ) ? SCHED_RR : -1;
            if( tpolicy < 0 ) 
               printf( "недопустимая политика планирования!\n" ), exit( EXIT_FAILURE );
            break;
         case 'v':
            debug++;
            break;
         default : exit( EXIT_FAILURE );
      }
   if( debug ) {
      printf( "parameters was:" );
      for( c = optind; c < argc; c++ ) printf( "\t<%s>", argv[ c ] );
      printf( "\n" );
   }
   return optind;
}

int main( int argc, char **argv, char **envp ) {
   printf( "число процессоров в SMP = %d\n", ncpu() );
   uint ind = getkey( argc, argv );
   if( argc == ind ) printf( "обижаешь, начальник!\n"), exit( EXIT_FAILURE ); 
   int i, n = 0;
   pthread_t *tids = calloc( argc - ind, sizeof( pthread_t ) );
   long* ret = calloc( argc - ind, sizeof( long ) );
   for( i = ind; i < argc; i++ ) {
      char *endptr;
      ret[ i - ind ] = strtol( argv[ i ], &endptr, 10 );
      if( *endptr != '\0' ) continue;
      n++;
   }
   printf( "планируется %d вычисляющих потоков\n", n );
   pthread_barrier_init( &bstart, NULL, n );
   for( i = 0; i < n; i++ ) {
      struct sched_param param;
      param.sched_priority = ret[ i ];
      int st;
      ret[ i ] = 0;      
      if( ( st = pthread_create( &tids[ i ], NULL, test, (void*)( ret + i ) ) ) != 0 )
         perror( "pthread_create" );
      if( 0 == st )
         if( ( st = pthread_setschedparam( tids[ i ], tpolicy, &param ) ) != 0 )
         perror( "pthread_setschedparam" );
   };
   signal( SIGALRM, handler );
   alarm( PAUSE );
   pause();
   for( i = 0; i < n; i++ ) 
      if( ret[ i ] != 0 )
         pthread_join( tids[ i ], NULL );
  printf( "выполнено циклов последовательно запущенными потоками: " );
  for( i = 0; i < n; i++ ) 
      printf( "%ld  ", ret[ i ] );
   printf( "\n" );
   return( EXIT_SUCCESS );
}
