#include "common.h"
static pthread_barrier_t bstart;
static pthread_barrier_t bwait;
static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

void* threadfunc ( void* data ) {
   int i = *(int*)data;
   pthread_barrier_wait( &bstart );
   struct timeval tv;
   gettimeofday( &tv, NULL );      // метка времени
   sleep( 1 );
   pthread_mutex_lock( &mutex );
   printf( "поток %u стартовал: %02lu:%06lu\n",
           i, ( tv.tv_sec % 60 ), tv.tv_usec );
   pthread_mutex_unlock( &mutex );
   pthread_barrier_wait( &bwait ); // ожидание завершения
   return NULL;
};

#define T 5                        // число потоков
int main( int argc, char *argv[] ) {
   if( pthread_barrier_init( &bwait, NULL, T + 1 ) != 0 ||
       pthread_barrier_init( &bstart, NULL, T ) != 0 )
      perror( "barrier init" ), exit( EXIT_FAILURE );
   pthread_t tid[ T ];
   for( uint i = 0; i < T; i++ )
      if( pthread_create( tid + i, NULL, threadfunc,
                          (void*)&i ) != 0 )
         perror( "thread create" ), exit( EXIT_FAILURE );
   pthread_barrier_wait( &bwait ); // ожидание завершения
   cout << "завершено выполнение " << T << " потоков" << endl;
   exit( EXIT_SUCCESS );
};
