#include "common.h"
static pthread_barrier_t bwait;

void* threadfunc ( void* data ) {
   sleep( 1 );
   pthread_barrier_wait( &bwait );
   return NULL;
};

#define T 10               // число потоков
int main( int argc, char *argv[] ) {
   if( pthread_barrier_init( &bwait, NULL, T + 1 ) != 0 )
      perror( "barrier init" ), exit( EXIT_FAILURE );
   pthread_t tid[ T ];
   for( uint i = 0; i < T; i++ )
      if( pthread_create( tid + i, NULL, threadfunc, NULL ) != 0 )
         perror( "thread create" ), exit( EXIT_FAILURE );
   pthread_barrier_wait( &bwait );

   cout << "завершено выполнение " << T << " потоков" << endl;
   exit( EXIT_SUCCESS );
};
