#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <pthread.h>

pthread_mutex_t loc;

static void* tfactor( void* par ) {             // функция потока
   static ulong result;
   ulong arg = (ulong)par;
   pthread_mutex_lock( &loc );
   result = arg <= 1 ? 1 :
            arg * *(ulong*)tfactor( (void*)( arg - 1 ) );  
   pthread_mutex_unlock( &loc );
   return &result;
};

int main( int argc, char *argv[] ) {
   int opt, mtype = PTHREAD_MUTEX_RECURSIVE;
   ulong narg = 6;
   while ( ( opt = getopt( argc, argv, "n" ) ) != -1 ) {
      switch( opt ) {
         case 'n' : mtype = PTHREAD_MUTEX_NORMAL; break;
         default : exit( EXIT_FAILURE );
       }
   };
   if( argc != optind && atoi( argv[ optind ] ) > 0 )
      narg = atoi( argv[ optind ] );
   printf( "факториал от %ld = ", narg ); 
   fflush( stdout );                          // вывод начала фразы ...
   pthread_mutexattr_t attr;
   pthread_mutexattr_init( &attr );
   // PROTOCOL (either PTHREAD_PRIO_NONE, PTHREAD_PRIO_INHERIT, or PTHREAD_PRIO_PROTECT).  
   pthread_mutexattr_setprotocol( &attr, PTHREAD_PRIO_INHERIT );
   // KIND (either PTHREAD_MUTEX_NORMAL, PTHREAD_MUTEX_RECURSIVE,
   //              PTHREAD_MUTEX_ERRORCHECK, or PTHREAD_MUTEX_DEFAULT)
   pthread_mutexattr_settype( &attr, mtype );
   pthread_mutex_init( &loc, &attr );         // инициализация мютекса
   pthread_mutexattr_destroy( &attr );
   pthread_t tid;
   if( pthread_create( &tid, NULL, tfactor, (void*)narg ) != 0 )
      perror( "thread create" ), exit( EXIT_FAILURE );
   ulong *thrret;
   pthread_join( tid, (void*)&thrret );
   printf( "%ld\n", *thrret );
   exit( EXIT_SUCCESS );
};
