#include "common.h"
#include <semaphore.h>

const int D = 10;
unsigned int T = 2;
static sem_t sem;
pthread_t* tid;

void* writer ( void* data ) {
   ulong i = (ulong)(data);
   unsigned int s = 1;
   while( i-- > 0 ) {
      delay( (long)rand_r( &s ) * D / RAND_MAX + 1 );
      sem_post( &sem );
   };
   for( i = 0; i < T; i++ ) pthread_cancel( tid[ i + 1 ] );
   return NULL;
};

static char *str;
static volatile unsigned ind = 0;

void* reader ( void* data ) {
   char cid = '0' + (ulong)data;
   unsigned int s = rand(); 
   pthread_setcanceltype( PTHREAD_CANCEL_DEFERRED, NULL );   
   while( true ) {
      sem_wait( &sem );
      str[ ind++ ] = cid; 
      pthread_testcancel();  
      delay( (long)rand_r( &s ) * D * T / RAND_MAX + 1 );
   };
   return NULL;
};

int main( int argc, char *argv[] ) {
   unsigned long N = 1000;
   int opt;
   while ( ( opt = getopt( argc, argv, "n:t:" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( atol( optarg ) > 0 ) N = atol( optarg );
            break;
         case 't' :
            if( atoi( optarg ) > 0 ) T = atoi( optarg );
            break;
         default : exit( EXIT_FAILURE );
       }
   };
   str = new char[ N + 1 ];
   tid = new pthread_t[ T + 1 ];
   if( sem_init( &sem, 0, 0 ) ) perror( "semaphore init" ), exit( EXIT_FAILURE );
   if( pthread_create( tid, NULL, writer, (void*)N ) != 0 )
      perror( "writer create error" ), exit( EXIT_FAILURE );
   ulong i;
   for( i = 0; i < T; i++ ) 
      if( pthread_create( tid + i + 1, NULL, reader, (void*)i ) != 0 )
         perror( "reader create error" ), exit( EXIT_FAILURE );
   for( i = 0; i < T; i++ ) pthread_join( tid[ i ], NULL );
   sem_destroy( &sem );
   delete [] tid;
   str[ ind ] = '\0';
   cout << str << endl;
   delete [] str;
   exit( EXIT_SUCCESS );
};

