#include "common.h"

class dbase : public list<element> {
   static const int READ_DELAY = 1, WRITE_DELAY = 2;
public:
   void add( const element& e, bool wait = true ) {
      int pos = size() * rand() / RAND_MAX;
      list<element>::iterator p = begin();
      for( int i = 0; i < pos; i++ ) p++;
      insert( p, e );
      if( wait ) delay( WRITE_DELAY );
   };
   int pos( const element& e ) {
      uint n = 0;
      for( list<element>::iterator i = begin(); i != end(); i++, n++ )
         if( *i == e ) { delay( READ_DELAY ); break; };
      if( n == size() )  n = -1;
      return n;
   };
} data;

int main( int argc, char *argv[] ) {
   params( argc, argv );
   cout << "wait ..." << flush;
   for( ulong i = 0; i < n; i++ ) 
      data.add( erand( n ), false );       // начальное заполнение
   struct timeval tb, tf;
   gettimeofday( &tb, NULL );
   for( ulong i = 0; i < n; i++ ) {        // последовательная обработка
      element e = erand( n );
      if( !wrand( p ) ) data.pos( e );
      else data.add( e );
   };
   gettimeofday( &tf, NULL );
   cout << "\r";
   timersub( &tf, &tb, &tf );
   long interv = tf.tv_sec * 1000L + tf.tv_usec / 1000L +
                 ( tf.tv_usec % 1000 > 500 ? 1 : 0 );
   cout << "интервал выполнения: " << interv << " миллисекунд" << endl;
   return EXIT_SUCCESS;
};
