#include "common.h"
#include <semaphore.h>

unsigned long N = 1000;
unsigned int T = 2;
static sem_t* sem;
static bool debug = false;
static char *str;
static volatile int ind = 0;
uint64_t *t;

void* threadfunc ( void* data ) {
   ulong i = 0;
   char cid = '0' + (ulong)data;
   if( (ulong)data == T - 1 ) {
      uint64_t c = rdtsc(); 
      for( uint i = 0; i < T; i++ ) t[ i ] = c;
   };
   while( i++ < N ) {
      sem_wait( sem + (ulong)data );
      if( debug ) str[ ind++ ] = cid;
      sem_post( sem + ( (ulong)data + 1 ) % T );
   };
   t[ (ulong)data ] = rdtsc() - t[ (ulong)data ];
   return NULL;
};

int main( int argc, char *argv[] ) {
   int opt;
   while ( ( opt = getopt( argc, argv, "n:t:v" ) ) != -1 ) {
      switch( opt ) {
         case 'n' :
            if( atol( optarg ) > 0 ) N = atol( optarg );
            break;
         case 't' :
            if( atoi( optarg ) > 0 ) T = atoi( optarg );
            break;
         case 'v' :
            debug = true;
            break;
         default : exit( EXIT_FAILURE );
       }
   };
   if( debug ) str = new char [ T * N + 1 ];   
   pthread_t* tid = new pthread_t[ T ];
   sem = new sem_t[ T ];   
   t = new uint64_t[ T ];
   ulong i;
   for( i = 0; i < T; i++ ) {
      if( sem_init( sem + i, 0, ( i == ( T - 1 ) ) ? 1 : 0 ) )
         perror( "semaphore init" ), exit( EXIT_FAILURE );
      if( pthread_create( tid + i, NULL, threadfunc, (void*)i ) != 0 )
         perror( "thread create error" ), exit( EXIT_FAILURE );
   };
   for( i = 0; i < T; i++ ) pthread_join( tid[ i ], NULL );
   for( i = 0; i < T; i++ ) sem_destroy( sem + i );
   delete [] sem;
   for( i = 0; i < T; i++ ) 
      cout << tid[ i ] << ": тактов = " << t[ i ] << ", на 1 семафор = " << t[ i ] / T / N << endl;
   delete [] tid;
   delete [] t;
   if( debug ) {
      str[ ind ] = '\0';
      cout << str << endl;
      delete [] str;
   };
   exit( EXIT_SUCCESS );
};

