#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <sys/time.h>

void put_msg( char *title, struct timeval *tv ) {
   printf( "%02lu:%06lu : %s\t: pid=%lu, tid=%lu\n",
           ( tv->tv_sec % 60 ), tv->tv_usec, title, (long)getpid(), pthread_self() );
}

void *test( void *in ) {
   struct timeval *tv = (struct timeval*)in;
   gettimeofday( tv, NULL );
   put_msg( "pthread started", tv );
   sleep( 5 );
   gettimeofday( tv, NULL );
   put_msg( "pthread finished", tv );
   return NULL;
}

#define TCNT 5

int main( int argc, char **argv, char **envp ) {
   pthread_t tid[ TCNT ];
   struct timeval tm;
   int i;
   gettimeofday( &tm, NULL );
   put_msg( "main started", &tm );
   for( i = 0; i < TCNT; i++ ) {
      int status = pthread_create( &tid[ i ], NULL, test, (void*)&tm );
         if( status != 0 ) perror( "pthread_create" ), exit( EXIT_FAILURE );
   };
   for( i = 0; i < TCNT; i++ ) 
      pthread_join( tid[ i ], NULL );
   gettimeofday( &tm, NULL );
   put_msg( "main finished", &tm );
   return( EXIT_SUCCESS );
}
